searchNodes=[{"ref":"Railyard.html","title":"Railyard","type":"module","doc":""},{"ref":"Railyard.html#ship/2","title":"Railyard.ship/2","type":"function","doc":""},{"ref":"Railyard.html#via_tuple/1","title":"Railyard.via_tuple/1","type":"function","doc":""},{"ref":"Railyard.Application.html","title":"Railyard.Application","type":"module","doc":"Starts a Registry to map resource spec names to Railyard.Resource process IDs, and a DynamicSupervisor to supervise those processes."},{"ref":"Railyard.Application.html#start/2","title":"Railyard.Application.start/2","type":"function","doc":"Called when an application is started. This function is called when an application is started using Application.start/2 (and functions on top of that, such as Application.ensure_started/2). This function should start the top-level process of the application (which should be the top supervisor of the application&#39;s supervision tree if the application follows the OTP design principles around supervision). start_type defines how the application is started: :normal - used if the startup is a normal startup or if the application is distributed and is started on the current node because of a failover from another node and the application specification key :start_phases is :undefined. {:takeover, node} - used if the application is distributed and is started on the current node because of a failover on the node node. {:failover, node} - used if the application is distributed and is started on the current node because of a failover on node node, and the application specification key :start_phases is not :undefined. start_args are the arguments passed to the application in the :mod specification key (e.g., mod: {MyApp, [:my_args]}). This function should either return {:ok, pid} or {:ok, pid, state} if startup is successful. pid should be the PID of the top supervisor. state can be an arbitrary term, and if omitted will default to []; if the application is later stopped, state is passed to the stop/1 callback (see the documentation for the c:stop/1 callback for more information). use Application provides no default implementation for the start/2 callback. Callback implementation for Application.start/2."},{"ref":"Railyard.Dsl.html","title":"Railyard.Dsl","type":"module","doc":"Use Railyard.Dsl in a module to turn it into a resource module."},{"ref":"Railyard.Dsl.html#resource/4","title":"Railyard.Dsl.resource/4","type":"macro","doc":"Defines a resource spec within the module. Name"},{"ref":"Railyard.Dsl.html#ship_after/1","title":"Railyard.Dsl.ship_after/1","type":"macro","doc":""},{"ref":"Railyard.Dsl.html#ship_before/1","title":"Railyard.Dsl.ship_before/1","type":"macro","doc":""},{"ref":"Railyard.Provider.html","title":"Railyard.Provider","type":"protocol","doc":"The protocol that a Railyard provider must implement in order to create resources of that type. See Railyard.Fs.File for a simple example."},{"ref":"Railyard.Provider.html#action/4","title":"Railyard.Provider.action/4","type":"function","doc":""},{"ref":"Railyard.Provider.html#cleanup/2","title":"Railyard.Provider.cleanup/2","type":"function","doc":""},{"ref":"Railyard.Provider.html#init/2","title":"Railyard.Provider.init/2","type":"function","doc":""},{"ref":"Railyard.Provider.html#ship/3","title":"Railyard.Provider.ship/3","type":"function","doc":""},{"ref":"Railyard.Provider.html#t:action/0","title":"Railyard.Provider.action/0","type":"type","doc":""},{"ref":"Railyard.Provider.html#t:bindings/0","title":"Railyard.Provider.bindings/0","type":"type","doc":""},{"ref":"Railyard.Provider.html#t:error/0","title":"Railyard.Provider.error/0","type":"type","doc":""},{"ref":"Railyard.Provider.html#t:ok_or_error/0","title":"Railyard.Provider.ok_or_error/0","type":"type","doc":""},{"ref":"Railyard.Provider.html#t:resource/0","title":"Railyard.Provider.resource/0","type":"type","doc":""},{"ref":"Railyard.Provider.html#t:state/0","title":"Railyard.Provider.state/0","type":"type","doc":""},{"ref":"Railyard.Provider.html#t:t/0","title":"Railyard.Provider.t/0","type":"type","doc":""},{"ref":"Railyard.Resource.html","title":"Railyard.Resource","type":"module","doc":"You probably don&#39;t want to use this directly. The Railyard module creates and terminates resources processes on demand, depending on the specs that are given to it. Go look at the Railyard module first, and if you&#39;re still curious how this works, come back here. Railyard.Resource defines the GenServer which will be responsible for supervising a specific instance of a resource. A Railyard.Resource requires a Railyard.ResourceSpec to define its behavior. Starting a resource does not necessarily perform an action. Resources can either be started when none existed, or a resource can be started on top of an existing resource, such as running mix railyard to provision cloud infrastructure."},{"ref":"Railyard.Resource.html#child_spec/1","title":"Railyard.Resource.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Railyard.Resource.html#delete/1","title":"Railyard.Resource.delete/1","type":"function","doc":"Delete this resource from the running infrastructure. In general, this will deprovision, delete, remove, or otherwise destroy the resource. This should be considered a permanent and unrecoverable action. If the provider returns :ok, then the GenServer will be shut down as well. If not, the genserver will stay alive, and the return value (assumed to be an error) will be returned to the caller."},{"ref":"Railyard.Resource.html#eval_property/3","title":"Railyard.Resource.eval_property/3","type":"function","doc":"See Railyard.ResourceSpec.eval_property/3."},{"ref":"Railyard.Resource.html#ship/2","title":"Railyard.Resource.ship/2","type":"function","doc":"Ship this resource to the running infrastructure. In general, this will cause resources to be provisioned if they don&#39;t exist, or brought into compliance with the current resource spec and parameter bindings if it does. The specific behavior of &quot;shipping&quot; a resource depends on the type of resource. See Railyard.Provider for provider details."},{"ref":"Railyard.Resource.html#start_link/1","title":"Railyard.Resource.start_link/1","type":"function","doc":""},{"ref":"Railyard.ResourceSpec.html","title":"Railyard.ResourceSpec","type":"module","doc":"Holds the template for a given resource. ResourceSpecs are data objects that, when combined with bindings, can be evaluated to produce a final value."},{"ref":"Railyard.ResourceSpec.html#eval_property/3","title":"Railyard.ResourceSpec.eval_property/3","type":"function","doc":""},{"ref":"Railyard.ResourceSpec.html#id/1","title":"Railyard.ResourceSpec.id/1","type":"function","doc":""},{"ref":"Railyard.Util.BlockMap.html","title":"Railyard.Util.BlockMap","type":"module","doc":"Provides a DSL for creating block templates, which can be hydrated with parameters."},{"ref":"Railyard.Util.BlockMap.html#create_block/1","title":"Railyard.Util.BlockMap.create_block/1","type":"macro","doc":"Creates a DSL block, which can later be evaluated to produce a map. Examples iex&gt; Railyard.Util.BlockMap.create_block do ...&gt; prop &quot;value&quot; ...&gt; end ...&gt; |&gt; Railyard.Util.BlockMap.eval_block [prop: &quot;value&quot;]"},{"ref":"Railyard.Util.BlockMap.html#eval_block/2","title":"Railyard.Util.BlockMap.eval_block/2","type":"function","doc":"Evaluates a block that was previously created with create_block. Examples iex&gt; Railyard.Util.BlockMap.create_block do ...&gt; prop &quot;value&quot; ...&gt; prop2 parameters.some_parameter ...&gt; prop3 do ...&gt; &quot;anything&quot; ...&gt; end ...&gt; end ...&gt; |&gt; Railyard.Util.BlockMap.eval_block(parameters: %{some_parameter: 1234}) [prop: &quot;value&quot;, prop2: 1234, prop3: &quot;anything&quot;]"},{"ref":"Railyard.Util.BlockMap.html#eval_property/2","title":"Railyard.Util.BlockMap.eval_property/2","type":"function","doc":""},{"ref":"Railyard.Util.BlockMap.html#eval_property/3","title":"Railyard.Util.BlockMap.eval_property/3","type":"function","doc":"Evaluates a single property out of a block. Examples iex&gt; Railyard.Util.BlockMap.create_block do ...&gt; prop test: &quot;value&quot;, test2: &quot;value2&quot; ...&gt; prop2 &quot;value2&quot; ...&gt; end ...&gt; |&gt; Railyard.Util.BlockMap.eval_property(:prop, []) {:prop, [test: &quot;value&quot;, test2: &quot;value2&quot;]} iex&gt; Railyard.Util.BlockMap.create_block do ...&gt; prop &quot;value&quot; ...&gt; end ...&gt; |&gt; Railyard.Util.BlockMap.eval_property(:prop, []) {:prop, &quot;value&quot;} iex&gt; Railyard.Util.BlockMap.create_block do ...&gt; prop &quot;value&quot;, &quot;value2&quot; ...&gt; end ...&gt; |&gt; Railyard.Util.BlockMap.eval_property(:prop, []) {:prop, [&quot;value&quot;, &quot;value2&quot;]} iex&gt; Railyard.Util.BlockMap.create_block do ...&gt; prop &quot;value&quot;, &quot;value2&quot; ...&gt; end ...&gt; |&gt; Railyard.Util.BlockMap.eval_property(:prop2, []) {:error, &quot;No such property prop2&quot;}"},{"ref":"Railyard.Distillery.html","title":"Railyard.Distillery","type":"module","doc":"The Railyard.Distillery module provides Railyard integration with Distillery, allowing the deployment lifecycle of an elixir app to be managed by Railyard."},{"ref":"Railyard.Fs.File.html","title":"Railyard.Fs.File","type":"module","doc":"Creates and manages a file on the filesystem. Fun fact: This was the first provider ever written!"},{"ref":"Mix.Tasks.Railyard.html","title":"Mix.Tasks.Railyard","type":"task","doc":""},{"ref":"Mix.Tasks.Railyard.html#run/1","title":"Mix.Tasks.Railyard.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"Railyard.Distillery.Plugin.html","title":"Railyard.Distillery.Plugin","type":"module","doc":"Provides a distillery plugin for adding config management lifecycle commands to the distillery build, and optionally for uploading packages to a file host like S3."},{"ref":"Railyard.Distillery.Plugin.html#after_assembly/1","title":"Railyard.Distillery.Plugin.after_assembly/1","type":"function","doc":""},{"ref":"Railyard.Distillery.Plugin.html#after_assembly/2","title":"Railyard.Distillery.Plugin.after_assembly/2","type":"function","doc":"Called after assembling the release. Should return a modified %Release{} or nil. Callback implementation for Mix.Releases.Plugin.after_assembly/2."},{"ref":"Railyard.Distillery.Plugin.html#after_cleanup/2","title":"Railyard.Distillery.Plugin.after_cleanup/2","type":"function","doc":"Called when the user invokes the mix release.clean task. The callback will be passed the command line arguments to mix release.clean. It should clean up the files the plugin created. The return value of this callback is ignored. Callback implementation for Mix.Releases.Plugin.after_cleanup/2."},{"ref":"Railyard.Distillery.Plugin.html#after_package/1","title":"Railyard.Distillery.Plugin.after_package/1","type":"function","doc":""},{"ref":"Railyard.Distillery.Plugin.html#after_package/2","title":"Railyard.Distillery.Plugin.after_package/2","type":"function","doc":"Called after packaging the release. Should return a modified %Release{} or nil. When in dev_mode, the packaging phase is skipped. Callback implementation for Mix.Releases.Plugin.after_package/2."},{"ref":"Railyard.Distillery.Plugin.html#before_assembly/1","title":"Railyard.Distillery.Plugin.before_assembly/1","type":"function","doc":""},{"ref":"Railyard.Distillery.Plugin.html#before_assembly/2","title":"Railyard.Distillery.Plugin.before_assembly/2","type":"function","doc":"Called before assembling the release. Should return a modified %Release{} or nil. Callback implementation for Mix.Releases.Plugin.before_assembly/2."},{"ref":"Railyard.Distillery.Plugin.html#before_package/1","title":"Railyard.Distillery.Plugin.before_package/1","type":"function","doc":""},{"ref":"Railyard.Distillery.Plugin.html#before_package/2","title":"Railyard.Distillery.Plugin.before_package/2","type":"function","doc":"Called before packaging the release. Should return a modified %Release{} or nil. When in dev_mode, the packaging phase is skipped. Callback implementation for Mix.Releases.Plugin.before_package/2."},{"ref":"readme.html","title":"Railyard","type":"extras","doc":"Railyard Railyard combines infrastructure as code and config management as a library within your Elixir application. It uses a Chef-like syntax to define resources within modules, which can be &quot;shipped&quot; (see Railyard.ship/2) to cloud providers, SaaS APIs, local configuration, etc."},{"ref":"readme.html#installation","title":"Railyard - Installation","type":"extras","doc":"Railyard can be installed by adding railyard to your list of dependencies in mix.exs: def deps do [ {:railyard, &quot;~&gt; 0.1.0&quot;} ] end Run mix deps.get to pull down the latest dependencies. Distillery Plugin Once installed, you may want to take advantage of the Distillery plugin to automatically provision cloud instances with your build. First, make sure that you&#39;ve defined a Railyard.Distillery resource in your infrastructure: defmodule MyApp.Infrastructure use Railyard.Dsl resource :distillery, Railyard.Distillery do # The Railyard.Distillery module docs describe how to set up this resource end end Install the plugin into an environment in your rel/config.exs file, and specify the Distillery resource that you&#39;re bundling: environment :prod do # ... Distillery config plugin Railyard.Distillery.Plugin, resource: {MyApp.Infrastructure, :distillery} end Distillery will now handle packaging and uploading releases in a way that will allow instances to automatically fetch and install releases during provisioning. Simply run MIX_ENV=prod mix release to build and upload a new version."},{"ref":"readme.html#getting-started","title":"Railyard - Getting Started","type":"extras","doc":"You&#39;re in the right place. The rest of this document will help you get oriented, and set up with some basic config management and infrastructure as code. For reference material, the Railyard and Railyard.Dsl modules are the best place to go. To get started with Railyard, there are a couple of terms that you will need to know. Resource Spec When writing code with Railyard, you will be writing resource specs. A resource spec describes what a resource should look like at a particular moment in time, but does not generally describe how to get there, or what changes to make along the way. A resource spec looks something like this: resource :my_file, Railyard.Fs.File do path &quot;./my_file.txt&quot; contents &quot;Hello, world!&quot; end Resource specs are written inside resource modules. Speaking of which... Resource Module A resource module is an Elixir module that has used Railyard.Dsl to define infrastructure components. Resource modules are the entrypoint for instantiating the infrastructure described in the resource specs. To elaborate on the above example... defmodule MyFiles do use Railyard.Dsl resource :my_file, Railyard.Fs.File do path &quot;./my_file.txt&quot; contents &quot;Hello, world!&quot; end end Resource A resource is the actual instance of the thing you wanted. A launched and running EC2 instance is a resource. A file on disk is a resource. A Resource is a genserver that supervises that resource, and ships changes to those resources. Ship To ship a resource requires two pieces: the resource spec as described above, and a set of bindings. To ship the resource module we defined earlier, we would do something like this: MyFiles.ship([]) Resource Provider"},{"ref":"changelog.html","title":"Change Log","type":"extras","doc":"Change Log Just makin it up as I go for now."}]